#include "libgccvb.h"
#include "charset.h"

#include "action53font.h"
#include "action54char.h"
#include "action54map.h"

#include "harrychar.h"
#include "harrymap.h"
#include "bricks.h"
#include "roomonemap.h"
#include "mariobricks.h"
#include "roomtwomap.h"
#include "bgonechar.h"
#include "bgonemap.h"
#include "doorchar2.h"
#include "doormap2.h"

#include "mt19937ar.c" // random number generator
#include "mouthopenmap.h"
#include "mouthopenchar.h"
#include "mouthclosedmap.h"
#include "mouthclosedchar.h"
#include "cherrymap.h"
#include "cherrychar.h"
#include "licoricemap.h"
#include "licoricechar.h"
#include "blankchar.h"
#include "blankmap.h"


#include "su11sfx.h"   // Sound engine header
#include "su11sfx.c"   // Sound engine implementation
#include "sounddat.h"  // Actual sounds

int harryx=70, harryanimtimer=0, harryy=325, crap=0, jumptimer=0, jumpanimtimer=-1, colltimer=0, crap2=0, dooranimtimer=0, doorx3, doorx4;
int doorx, doorx2, doory, batanim=0, batanimtimer=0, batx, baty, batdir=0, batanimy=0, scorehundredthousands;
char x=0, y=0, harryanim=0, jump=0, dooranim=96, roomnumber=1, collision;
char selectgame=1, game=54, bpressed=0, score, scorehundreds, scorethousands, scoretenthousands;


char bump=0, foodspeed, mouthopen, mouthclosed, foodcounter;
int foodx=400, foody=400, fooddecide, scoretimer, scoredigits;

HWORD getBGMapChar(bgmap, harryx, harryy)
    	{ 
     	return (BGMM[(0x1000) + (harryy * 64) + harryx]&0x7FF);  
    	} 
		
void WaitForVIP () {

  while(!(VIP_REGS[INTPND] & XPEND)); 
  VIP_REGS[INTCLR] = XPEND;
}
		
		
int main()
{	

	game=54;
	InitSound();
	copymem((void*)CharSeg0, (void*)ACTION54CHAR, 256*16);
	copymem((void*)BGMap(0), (void*)ACTION54MAP, 256*16);	


	
	StopAllSounds();

	SND_REGS[1].SxLRV = 0;
	SND_REGS[2].SxLRV = 0;	
	SND_REGS[3].SxLRV = 0;	
	SND_REGS[4].SxLRV = 0;		
	
	PlaySound(menusong); 
	PlaySound(menubass);
    PlaySound(menubass2);


	vbDisplayOn();
	vbDisplayShow();


	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(26, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(25, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	


		game=0;
	
while(game==0)
{

	if (vbReadPad()&K_B) bpressed=1;
	if ((!(vbReadPad()&K_B) && (bpressed==1))) bpressed=0, selectgame++;
	if (selectgame>2) selectgame=1;
	
	copymem((void*)CharSeg3, (void*)ACTION53FONT, 8192);	
	
	if (selectgame==1)
	{
	vbTextOut(0, 9, 1,".");
	vbTextOut(0, 9, 2," ");
	}
	
		if (selectgame==2)
	{
	vbTextOut(0, 9, 1," ");
	vbTextOut(0, 9, 2,".");
	}
	
	
	vbTextOut(0, 10, 1,"CASTLE OF DOOM");	
	vbTextOut(0, 10, 2,"THE CANDYMAN  ");		

	if ((vbReadPad()&K_STA) && (selectgame==1)) roomnumber=1, game=1;
	if ((vbReadPad()&K_STA) && (selectgame==2)) foodspeed=8, foody=400, game=2;

	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);

	DoSounds();


}

while(game==1)
{


	

	SND_REGS[1].SxLRV = 0;
	SND_REGS[2].SxLRV = 0;	
	SND_REGS[3].SxLRV = 0;	
	SND_REGS[4].SxLRV = 0;	

	
	StopAllSounds();	
	
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);

	copymem((void*)CharSeg0, (void*)HARRYCHAR, 256*16);
	copymem((void*)BGMap(0), (void*)HARRYMAP, 256*16);	
	
	copymem((void*)CharSeg1, (void*)BRICKS, 256*16);
	copymem((void*)BGMap(1), (void*)ROOMONEMAP, 256*16);		
	
	copymem((void*)CharSeg2, (void*)BGONECHAR, 256*16);
	copymem((void*)BGMap(2), (void*)BGONEMAP, 256*16);		
	
	copymem((void*)CharSeg3, (void*)DOORCHAR2, 256*16);
	copymem((void*)BGMap(3), (void*)DOORMAP2, 256*16);	
	
    //Setup worlds
	
	dooranim=96, harryx=70, harryy=168, doorx=154, doorx2=146, doory=72;	
	batx=400, baty=300;

	
    //vbSetWorld(31, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);	

    //vbSetWorld(31, WRLD_ON|2, 0, 2, 0, 0, 0, 0, 384, 224);





	
	//vbDisplayOn();
	//vbDisplayShow();

    //Main game loop
    while(1)
    {
	if (vbReadPad()&K_SEL) main();

	vbSetWorld(31, WRLD_ON|2, -1, -2, 0, 0, 0, 0, 384, 224);


	VIP_REGS[GPLT1]=0x24;
    vbSetWorld(29, WRLD_ON|3, doorx, -2, doory, 0, 0, 0, 15, 32);
	//vbSetWorld(25, WRLD_ON|3, doorx2, -2, doory, dooranim, 0, 0, 0, 0);
	
	//vbSetWorld(29, WRLD_ON|3, doorx2, -2, doory, dooranim, 0, 0, 0, 0);
	
	
	vbSetWorld(28, WRLD_ON|1, -1, -2, 0, 0, 0, 0, 384, 224);
    vbSetWorld(27, WRLD_ON, harryx, -2, harryy, harryanim, 0, 0, 7, 32);
    //vbSetWorld(29, WRLD_ON|3, doorx, -2, doory, 0, 0, 0, 15, 32);
	x=0;
	crap=x;


	doorx3=doorx+8;
	doorx4=doorx+1;

	if ((dooranim>16) && (dooranim<81))
	{
	dooranimtimer++;
	
    vbSetWorld(29, WRLD_ON|3, doorx, -2, doory, 0, 0, 0, 15, 32);	
	vbSetWorld(30, WRLD_ON|3, doorx2, -2, doory, dooranim, 0, 0, 0, 0);
	vbSetWorld(26, WRLD_ON|3, doorx2, -2, doory, dooranim, 0, 0, 14, 32);
	if (dooranimtimer>500) harryy=326;	
	}
	if (dooranim<33) vbSetWorld(26, WRLD_ON|3, doorx2+2, -2, doory, dooranim, 0, 0, 14, 32);

	if (dooranim==96)
	{
	vbSetWorld(30, WRLD_ON|3, doorx2, -2, doory, dooranim, 0, 0, 14, 32);
	vbSetWorld(26, WRLD_ON|3, doorx2, -2, doory, dooranim, 0, 0, 0, 0);	
	}

	if ((dooranimtimer>30) && (dooranim>32)) dooranim=dooranim-16, doorx2=doorx2+2, dooranimtimer=0;
	if (dooranim<16) dooranim=0;

	if (dooranim<16)
	{
	dooranimtimer++;
	

	vbSetWorld(30, WRLD_ON|3, doorx2, -2, doory, dooranim, 0, 0, 0, 0);
	vbSetWorld(26, WRLD_ON|3, doorx2, -2, doory, dooranim, 0, 0, 14, 32);		
	}

	if (dooranim>88)
	{
	if (vbReadPad()&K_LL) harryanimtimer++, x=255;
	if (vbReadPad()&K_LR) harryanimtimer++, x=1;

	if ((vbReadPad()&K_LR) && (harryanim>24)) harryanim=0;
	if ((vbReadPad()&K_LL) && (harryanim<34)) harryanim=34;
	if ((vbReadPad()&K_LL) && (harryanim>55)) harryanim=34;
	}

	y=0;


	if (!(vbReadPad()&K_A) && (jump==1)) jump=2;
	if ((vbReadPad()&K_A) && (jump==0)) jump=1;
	
	if (jump==1) jumpanimtimer++;
	
	if ((jump==1) && (jumpanimtimer>0)) jumpanimtimer=0, y=255, jumptimer++;
	if ((jump>1) && (jumpanimtimer>0)) jumpanimtimer=0, y=1, jumptimer++;
	
	if (jumptimer>80) jumptimer=0, jump=2, harryy++;
	
	if (harryanimtimer>9) harryanimtimer=0, harryanim=harryanim+8;

	if (roomnumber>1) 
	{
	vbSetWorld(25, WRLD_ON, batx, -2, baty, 88, 0, batanimy, 16, 14);
	
	if (batx==360) batdir=1;
	if (batx==10) batdir=0;
	
	if (batdir==0) batx++;
	if (batdir==1) batx--;
	batanimtimer++;
	if (batanimtimer>70) batanimtimer=0, batanimy=batanimy+14;
	if (batanimy==28) batanimy=0;
	}

	colltimer=0;

	if (harryx<10) harryx=360;
	if (harryx>360) harryx=10;
	
	if ((colltimer==0) && (getBGMapChar(1, (harryx/8)+0, (harryy/8)+3)==512)) colltimer=1, harryx++;
	if ((colltimer==0) && (getBGMapChar(1, (harryx/8)+1, (harryy/8)+3)==512)) colltimer=1, harryx--;

	if ((colltimer==0) && (getBGMapChar(1, (harryx/8)+0, (harryy/8)+2)==512)) colltimer=1, harryx++;
	if ((colltimer==0) && (getBGMapChar(1, (harryx/8)+1, (harryy/8)+2)==512)) colltimer=1, harryx--;
	
	if ((colltimer==0) && (getBGMapChar(1, (harryx/8)+0, (harryy/8)+1)==512)) colltimer=1, harryx++;
	if ((colltimer==0) && (getBGMapChar(1, (harryx/8)+1, (harryy/8)+1)==512)) colltimer=1, harryx--;	

	if ((jump==0) && (!(getBGMapChar(1, (harryx/8)+0, (harryy/8)+4)==512))) y=1, jump=2;
	if ((jump==0) && (!(getBGMapChar(1, (harryx/8)+1, (harryy/8)+4)==512))) y=1, jump=2;	
	
	if ((jump>1) && (getBGMapChar(1, (harryx/8)+0, (harryy/8)+4)==512)) jumpanimtimer=-1, y=0, jump=0, jumptimer=0;
	if ((jump>1) && (getBGMapChar(1, (harryx/8)+1, (harryy/8)+4)==512)) jumpanimtimer=-1, y=0, jump=0, jumptimer=0;
	
	if ((baty-16<harryy) && (baty+16>harryy)) collision=1;
	if ((batx-6<harryx) && (batx+18>harryx) && (collision==1)) harryy=275;
	
	collision=0;

	if ((jump==1) && (getBGMapChar(1, (harryx/8)+0, (harryy/8)+0)==512)) jump=2;
	if ((jump==1) && (getBGMapChar(1, (harryx/8)+1, (harryy/8)+0)==512)) jump=2;	
	if (jump==2) y=1;		
	
	if ((vbReadPad()&K_LU) && (dooranim==96) && (getBGMapChar(1, (harryx/8)-1, (harryy/8)+4)==512) && (harryx>doorx4) && (harryx<doorx3)) dooranim=80;

	harryx=harryx+x, harryy=harryy+y;

	if ((jumptimer>2) && (getBGMapChar(1, (harryx/8)+0, (harryy/8)+4)==512)) colltimer=1, harryx++;
	if ((jumptimer>2) && (getBGMapChar(1, (harryx/8)+1, (harryy/8)+4)==512)) colltimer=1, harryx--;

	if (harryy>224) 
	{
	if (dooranimtimer>499) roomnumber++;

	jump=0, jumptimer=0, dooranimtimer=0;
	
	switch(roomnumber)
	{
	case 1:
	copymem((void*)CharSeg1, (void*)BRICKS, 256*16);
	copymem((void*)BGMap(1), (void*)ROOMONEMAP, 256*16);	
	dooranim=96, harryx=70, harryy=168, doorx=154, doorx2=146, doory=72;
	break;
	
	case 2:
	copymem((void*)CharSeg1, (void*)MARIOBRICKS, 256*16);
	copymem((void*)BGMap(1), (void*)ROOMTWOMAP, 256*16);	
	dooranim=96, batx=160, baty=50, harryx=130, harryy=84, doorx=230, doorx2=222, doory=168;
	break;

	// default code is level 2
	default:
	copymem((void*)CharSeg1, (void*)MARIOBRICKS, 256*16);
	copymem((void*)BGMap(1), (void*)ROOMTWOMAP, 256*16);	
	dooranim=96, batx=160, baty=50, harryx=130, harryy=84, doorx=230, doorx2=222, doory=168;
	break;	
	}
	}
	}
	}

while(game==2)
{
	char score_str[5];
	
	//copymem ((void*)CharSeg3, (void*)ACTION53FONT, 8192);	
	
	if (score>99) scorehundreds++, score=0;
	if (scorehundreds>9) scorehundreds=0, scorethousands++;
	if (scorethousands>9) scorethousands=0, scoretenthousands++;



	
	vbTextOut(0, 12, 1, score_str);
	score_str[4]=(score%10)+'0';
	score_str[3]=(score/10)+'0';
	score_str[2]=(scorehundreds%10)+'0';	
	score_str[1]=(scorethousands%10)+'0';
	score_str[0]=(scoretenthousands%10)+'0';
	
	if (scoretenthousands>9)
	{
	score_str[4]='.';
	score_str[3]='A';
	score_str[2]='O';	
	score_str[1]='H';
	score_str[0]='W';
	
	}
	


	if (vbReadPad()&K_SEL) main();

	SND_REGS[1].SxLRV = 0;
	SND_REGS[2].SxLRV = 0;	
	SND_REGS[3].SxLRV = 0;	
	SND_REGS[4].SxLRV = 0;	


	
	StopAllSounds();	
	
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 172, 224);
	vbSetWorld(30, WRLD_ON|1, foodx, 0, foody, 0, 0, 0, 100, 100);
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);

	if (bump==0) foodx=foodx-foodspeed;
	if ((foodx<40) && (bump==0) && (mouthclosed==1)) bump=1;
	if ((foodx<40) && (mouthopen==1)) foody=400;
	
	if ((fooddecide==1) && (foodx<40) && (mouthopen==1)) foodcounter++, score++;
	if ((fooddecide !=1) && (foodx<40) && (mouthopen==0)) foodcounter++, score++;	
	
	//score=score+9;
	
	if ((foodcounter>9) && (foodspeed<16)) foodspeed++;
	if (foodcounter>9) foodcounter=0;
	
	
	if (bump==1) foodx=foodx+foodspeed+2, foody=foody+8;
	
	if (fooddecide==1)
	{
	copymem((void*)CharSeg1, (void*)LICORICECHAR, 256*16);
	copymem((void*)BGMap(1), (void*)LICORICEMAP, 256*16);	
	}
	
	if (fooddecide !=1)
	{
	copymem((void*)CharSeg1, (void*)CHERRYCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)CHERRYMAP, 256*16);	
	}	
	
	if (foody>300) foodx=400, foody=160, bump=0, fooddecide=genrand_int32()%2;	
	//copymem((void*)CharSeg0, (void*)BLANKCHAR, 512*16);
	//copymem((void*)BGMap(0), (void*)BLANKMAP, 512*16);		
	
	//while (VIP_REGS[XPSTTS] & XPBSYR);	
	
	
	if  ((vbReadPad()&K_A) && (mouthopen==1))   WaitForVIP();	
	if  (!(vbReadPad()&K_A) && (mouthclosed==1))   WaitForVIP();	
	
	if (vbReadPad()&K_A) 
	{
	mouthopen=0, mouthclosed=1;
	copymem((void*)CharSeg0, (void*)MOUTHCLOSEDCHAR, 256*16);
	copymem((void*)BGMap(0), (void*)MOUTHCLOSEDMAP, 256*16);	
	}

	if (!(vbReadPad()&K_A))
	{
	mouthopen=1, mouthclosed=0;	
	copymem((void*)CharSeg0, (void*)MOUTHOPENCHAR, 256*16);
	copymem((void*)BGMap(0), (void*)MOUTHOPENMAP, 256*16);	
	}
	
	



	}
}	
	